Mercurial > hg
view tests/run-tests @ 500:ebc4714a7632
[PATCH] Clean up destination directory if a clone fails.
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1
[PATCH] Clean up destination directory if a clone fails.
From: Bryan O'Sullivan <bos@serpentine.com>
On Mon, 2005-06-27 at 16:27 +0800, Soh Tk-r28629 wrote:
> Hg clone left the dest directory if the source isn't valid.
> I think it should either validate the source before mkdir, or do a
> rmdir to clean it up.
Good suggestion, thanks. As validating the source in advance isn't
really practical, I opted for the latter.
manifest hash: 1508afddd2402142f9d8b2387652d4cb28ccc1f5
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.0 (GNU/Linux)
iD8DBQFCwRGPywK+sNU5EO8RApBOAJ9Fj22MP3pYJhxWsj8BYbcgWzIOKwCff9yC
lX87RrDKicM1W61lBpQl20w=
=efck
-----END PGP SIGNATURE-----
author | mpm@selenic.com |
---|---|
date | Tue, 28 Jun 2005 00:59:59 -0800 |
parents | e94cebc60d96 |
children | 3d4d5f2aba9a 4fc63e22b1fe |
line wrap: on
line source
#!/bin/bash set -e export LANG=C export LC_CTYPE="C" export LC_NUMERIC="C" export LC_TIME="C" export LC_COLLATE="C" export LC_MONETARY="C" export LC_MESSAGES="C" export LC_PAPER="C" export LC_NAME="C" export LC_ADDRESS="C" export LC_TELEPHONE="C" export LC_MEASUREMENT="C" export LC_IDENTIFICATION="C" export LC_ALL="" umask 022 tests=0 failed=0 H=$PWD if [ -d /usr/lib64 ]; then lib=lib64 else lib=lib fi TESTPATH=$PWD/install/bin export PATH=$TESTPATH:$PATH export PYTHONPATH=$PWD/install/$lib/python rm -rf install cd .. ${PYTHON:-python} setup.py install --home=tests/install > tests/install.err if [ $? != 0 ] ; then cat tests/install.err fi cd $H rm install.err function run_one { rm -f $1.err export TZ=GMT D=`mktemp -d` if [ "$D" == "" ] ; then echo mktemp failed! fi cd $D fail=0 if ! $H/$1 > .out 2>&1 ; then echo $1 failed with error code $? fail=1 fi if [ -s .out -a ! -r $H/$1.out ] ; then echo $1 generated unexpected output: cat .out cp .out $H/$1.err fail=1 elif [ -r $H/$1.out ] && ! diff -u $H/$1.out .out > /dev/null ; then echo $1 output changed: diff -u $H/$1.out .out && true cp .out $H/$1.err fail=1 fi cd $H rm -r $D return $fail } TESTS=$@ if [ "$TESTS" == "" ] ; then TESTS=`ls test-* | grep -Ev "\.|~"` fi for f in $TESTS ; do echo -n "." if ! run_one $f ; then failed=$[$failed + 1] fi tests=$[$tests + 1] done rm -rf install echo echo Ran $tests tests, $failed failed if [ $failed -gt 0 ] ; then exit 1 fi